#include <stdio.h>
#include <stdlib.h>
#include "dre_app.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_app_handle *h = NULL;
    char *name = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else goto arg;
    }
    if(!name) goto arg;

    /* open handler */
    h = dre_app_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* get status */
    result = dre_app_get_status(h);
    if(result == DRE_APP_CONTAINER_STATUS_STOP) {
        printf("'%s' is STOPPED.\n", name);
    } else if(result == DRE_APP_CONTAINER_STATUS_RUNNING) {
        printf("'%s' is RUNNING.\n", name);
    } else if(result == DRE_APP_CONTAINER_STATUS_SUSPENDED) {
        printf("'%s' is SUSPENDED.\n", name);
    } else if(result == DRE_APP_CONTAINER_STATUS_BUSY) {
        printf("'%s' is BUSY.\n", name);
    } else {
        result = DRE_ERR_CONTAINER_UNKNOWN_STATUS;
        goto error;
    }

    /* close handler */
    result = dre_app_close(h);
    if(result) goto error;

    return 0;

arg:
    printf("usage: %s -n <name>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_app_close(h);
    }

    printf("Failed to get status (ErrNo=%d).\n", result);
    return result;
}

