#include <stdio.h>
#include <string.h>
#include <regex.h>

const char*
get_container_name()
{
    static int init = 0;
    static char *container_name = "";

    if (init == 0) {
        init = 1;

        FILE *fp = fopen("/proc/self/cgroup","r");
        if (fp == NULL) {
            perror("fopen");
        } else {
            char buf[256];
            char *ret = fgets(buf, sizeof(buf), fp);
            fclose(fp);

            if (ret) {
#if 1
                regex_t preg;
                size_t nmatch = 2;
                regmatch_t pmatch[nmatch];
                char pattern[] = ".*[:,]ns[:,].*:/(.*)";

                if (regcomp(&preg, pattern, REG_NEWLINE|REG_EXTENDED) == 0) {
                    if (regexec(&preg, buf, nmatch, pmatch, 0) == 0) {
                        if (0 <= pmatch[1].rm_so && 
                            0 <= pmatch[1].rm_eo &&
                            pmatch[1].rm_so <= pmatch[1].rm_eo) {

                            buf[pmatch[1].rm_eo] = '\0';
                            char *p = &buf[pmatch[1].rm_so];
                            container_name = strdup(p);
                            //printf("[%s]\n", container_name);
                        }
                    }

                    regfree(&preg);
                }
#else
                if (buf[strlen(buf) - 1] == '\n') {
                    buf[strlen(buf) - 1] = '\0';
                }

                ret = strchr(buf, '/');
                if (ret && 1 < strlen(ret)) {
                    container_name = strdup(ret);
                }
#endif
            }
        }
    }

    return container_name;
}

int
is_container()
{
    const char *name = get_container_name();
    return (name && 0 < strlen(name) ? 1 : 0);
}

char *
daware_get_container_name(char *name, size_t len)
{
    strncpy(name, get_container_name(), len);
    return name;
}

