#include <stdio.h>
#include <stdlib.h>
#include "dre_app.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_app_handle *h = NULL;
    char *name = NULL;
    char *cgroup = NULL;
    char *exec = argv[0];
    char **p = ++argv;
    
    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else if(!strcmp(argv[i], "-g") && p[i + 1]) {
            cgroup = argv[++i];
        } else goto arg;
    }
    if(!cgroup) goto arg;

    /* open handler */
    if(name) {
        h = dre_app_open(name);
        if(!h) {
            result = DRE_ERR_NULL_POINTER;
            goto error;
        }
    }

    /* destroy control group */
    result = dre_app_destroy_cgroup(h, cgroup);
    if(result) goto error;

    /* close handler */
    if(h) {
        result = dre_app_close(h);
        if(result) goto error;
    }

    printf("Destroyed cgroup '%s'.\n", cgroup);
    return 0;

arg:
    printf("usage: %s -g <cgroup> [-n <name>]\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_app_close(h);
    }

    printf("Failed to destroy '%s' (ErrNo=%d).\n", cgroup, result);
    return result;
}

