#include <stdio.h>
#include <stdlib.h>
#include "dre_sys.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_sys_handle *h = NULL;
    char *name = NULL;
    char *tag = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else if(!strcmp(argv[i], "-g") && p[i + 1]) {
            tag = argv[++i];
        } else goto arg;
    }
    if(!name && !tag) goto arg;

    /* open handler */
    h = dre_sys_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* remove checkpoint */
    result = dre_sys_remove_checkpoint(h, tag);
    if(result) goto error;

    /* close handler */
    result = dre_sys_close(h);
    if(result) goto error;

    printf("Removed checkpoint '%s'.\n", tag);
    return 0;

arg:
    printf("usage: %s -n <name> -t <tag>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_sys_close(h);
    }

    printf("Failed to remove checkpoint '%s' (ErrNo=%d).\n", tag, result);
    return result;
}

